"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = require("@angular/common/http");
var object_1 = require("core-js/fn/object");
var RestangularHelper = /** @class */ (function () {
    function RestangularHelper() {
    }
    RestangularHelper.createRequest = function (options) {
        var requestQueryParams = RestangularHelper.createRequestQueryParams(options.params);
        var requestHeaders = RestangularHelper.createRequestHeaders(options.headers);
        var methodName = options.method.toUpperCase();
        var withCredentials = options.withCredentials || false;
        var request = new http_1.HttpRequest(methodName, options.url, options.data, {
            headers: requestHeaders,
            params: requestQueryParams,
            responseType: options.responseType,
            withCredentials: withCredentials
        });
        if (['GET', 'DELETE', 'HEAD', 'JSONP', 'OPTIONS'].indexOf(methodName) >= 0) {
            request = new http_1.HttpRequest(methodName, options.url, {
                headers: requestHeaders,
                params: requestQueryParams,
                responseType: options.responseType,
                withCredentials: withCredentials
            });
        }
        return request;
    };
    RestangularHelper.createRequestQueryParams = function (queryParams) {
        var requestQueryParams = object_1.assign({}, queryParams);
        var search = new http_1.HttpParams();
        var _loop_1 = function (key) {
            var value = requestQueryParams[key];
            if (Array.isArray(value)) {
                value.forEach(function (val) {
                    search = search.append(key, val);
                });
            }
            else {
                if (typeof value === 'object') {
                    value = JSON.stringify(value);
                }
                search = search.append(key, value);
            }
        };
        for (var key in requestQueryParams) {
            _loop_1(key);
        }
        return search;
    };
    RestangularHelper.createRequestHeaders = function (headers) {
        for (var key in headers) {
            var value = headers[key];
            if (typeof value === 'undefined') {
                delete headers[key];
            }
        }
        return new http_1.HttpHeaders(object_1.assign({}, headers));
    };
    return RestangularHelper;
}());
exports.RestangularHelper = RestangularHelper;
//# sourceMappingURL=ngx-restangular-helper.js.map