"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/throw");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
require("rxjs/add/operator/filter");
var ngx_restangular_helper_1 = require("./ngx-restangular-helper");
var RestangularHttp = /** @class */ (function () {
    function RestangularHttp(http) {
        this.http = http;
    }
    RestangularHttp.prototype.createRequest = function (options) {
        var request = ngx_restangular_helper_1.RestangularHelper.createRequest(options);
        return this.request(request);
    };
    RestangularHttp.prototype.request = function (request) {
        var _this = this;
        return this.http.handle(request)
            .filter(function (event) { return event instanceof http_1.HttpResponse; })
            .map(function (response) {
            if (!response.ok) {
                return Observable_1.Observable.throw(new http_1.HttpErrorResponse(response));
            }
            return response;
        })
            .map(function (response) {
            response.config = { params: request };
            return response;
        })
            .catch(function (err) {
            err.request = request;
            err.data = err.error;
            err.repeatRequest = function (newRequest) {
                return _this.request(newRequest || request);
            };
            return Observable_1.Observable.throw(err);
        });
    };
    RestangularHttp.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    RestangularHttp.ctorParameters = function () { return [
        { type: http_1.HttpBackend, },
    ]; };
    return RestangularHttp;
}());
exports.RestangularHttp = RestangularHttp;
//# sourceMappingURL=ngx-restangular-http.js.map